<?xml version="1.0" encoding="utf-8" ?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="fr" lang="fr">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
<meta name="generator" content="RestructWeb 0.1: http://www.ombrepixel.com/drobert/restructweb.html - Docutils 0.3.2: http://docutils.sourceforge.net/" />
<title>reStructWeb</title>
<link rel="stylesheet" href="default.css" type="text/css" />
</head>
<body>
<div align="center">
Site perso de David ROBERT - <a href="index.html.fr">Page d'accueil</a>
</div>
<hr />
<div class="document" id="restructweb">
<h1 class="title">reStructWeb</h1>
<p>reStructWeb est un petit programme en langage <a class="reference" href="http://www.python.org/">Python</a> que j'ai écrit pour gérer
mon site Web personnel. Les fonctions principales que je souhaitai lorsque j'ai
décidé de le faire sont :</p>
<ul class="simple">
<li>Pouvoir modifier mon site simplement et en ligne.</li>
<li>Ne pas avoir à écrire mes pages en html ou en xml</li>
<li>Avoir un système de liens entre les pages très simple (comme les <a class="reference" href="http://c2.com/cgi/wiki?WikiWikiWeb">Wiki</a>)</li>
<li>Intégrer un système de template et css pour séparer la présentation du contenu</li>
<li>Être multi-langue</li>
<li>Être performant et léger pour mon pauvre serveur (<a class="autolink reference" href="apropos.html.fr">Apropos</a>).</li>
</ul>
<p>Je me suis inspiré du système <a class="reference" href="http://c2.com/cgi/wiki?WikiWikiWeb">Wiki</a> pour mettre à jour mon site Web.
Les pages sont créées en format texte via le format <a class="reference" href="http://docutils.sourceforge.net/rst.html">reStructuredText</a>.
Regardez par exemple la source de ce document en cliquant sur le lien
<em>Source</em> en bas de la page.</p>
<hr />
<div class="contents topic" id="sommaire">
<p class="topic-title first"><a name="sommaire">Sommaire</a></p>
<ul class="simple">
<li><a class="reference" href="#outils-n-cessaires" id="id6" name="id6">Outils nécessaires</a></li>
<li><a class="reference" href="#principe-et-performances" id="id7" name="id7">Principe et performances</a></li>
<li><a class="reference" href="#ce-que-restructweb-n-est-pas" id="id8" name="id8">Ce que reStructWeb n'est pas</a></li>
<li><a class="reference" href="#t-l-chargement" id="id9" name="id9">Téléchargement</a></li>
<li><a class="reference" href="#configuration" id="id10" name="id10">Configuration</a><ul>
<li><a class="reference" href="#mode-standalone" id="id11" name="id11">Mode standalone</a></li>
<li><a class="reference" href="#mode-redirection-par-apache" id="id12" name="id12">Mode redirection par Apache</a></li>
<li><a class="reference" href="#ma-configuration" id="id13" name="id13">Ma configuration</a></li>
<li><a class="reference" href="#templates" id="id14" name="id14">Templates</a><ul>
<li><a class="reference" href="#int-ret" id="id15" name="id15">Intéret</a></li>
<li><a class="reference" href="#balises" id="id16" name="id16">Balises</a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference" href="#bugs-a-faire" id="id17" name="id17">Bugs / A faire</a></li>
<li><a class="reference" href="#autres-projets" id="id18" name="id18">Autres projets</a></li>
</ul>
</div>
<hr />
<div class="section" id="outils-n-cessaires">
<h1><a class="toc-backref" href="#id6" name="outils-n-cessaires">Outils nécessaires</a></h1>
<p>reStructWeb est basé sur les outils suivants :</p>
<ul class="simple">
<li><a class="reference" href="http://www.python.org/">Python</a></li>
<li><a class="reference" href="http://docutils.sourceforge.net/">Docutils</a></li>
<li><a class="reference" href="http://www.apache.org/">Apache</a></li>
</ul>
<p>A l'heure actuelle reStructWeb fait à peine plus de 300 lignes de code.
Le plus gros du travail (la gestion du format <a class="reference" href="http://docutils.sourceforge.net/rst.html">reStructuredText</a>) est fait par
<a class="reference" href="http://docutils.sourceforge.net/">Docutils</a></p>
<p>reStructWeb a été testé sur les environnements suivants :</p>
<ul class="simple">
<li>Red Hat 9</li>
<li>Red Hat 8</li>
<li>Debian Sarge</li>
<li><a class="reference" href="http://www.python.org/">Python</a> 2.2.2, 2.2.3, 2.3.3</li>
<li><a class="reference" href="http://www.apache.org/">apache</a> 2.0.40</li>
<li><a class="reference" href="http://docutils.sourceforge.net/">docutils</a> snapshot téléchargé le 2 mai 2004</li>
</ul>
<p>Le programme devrait fonctionner sur n'importe quel système supportant
<a class="reference" href="http://www.python.org/">Python</a> 2.2 (ou plus) et <a class="reference" href="http://docutils.sourceforge.net/">docutils</a>.</p>
</div>
<div class="section" id="principe-et-performances">
<h1><a class="toc-backref" href="#id7" name="principe-et-performances">Principe et performances</a></h1>
<p>Le système utilisé est très performant. La majorité du temps, les pages sont
envoyées au navigateur directement par Apache (pages statiques). Deux cas de figures vont amener Apache à renvoyer la requête sur le script reStructWeb :</p>
<ol class="arabic simple">
<li>L'URL demandée n'existe pas</li>
<li>L'URL demandée contient des paramètres</li>
</ol>
<p>Le script va proposer de créer une page si elle n'existe pas ou proposer
la modification d'une page existante. Elle génère par la suite les pages
html dans les différentes langues et Apache pourra les envoyer de manière
traditionnelle.</p>
<p><a class="reference" href="http://www.apache.org/">Apache</a> nécessite une petite configuration pour renvoyer les requêtes vers
reStructWeb. On peut toutefois fonctionner utiliser reStructWeb de manière
traditionnelle comme un cgi, par exemple :</p>
<p>Avec configuration d'Apache :</p>
<pre class="literal-block">
http://www.test.com/index.html.fr
</pre>
<p>Sans configuration d'Apache :</p>
<pre class="literal-block">
http://www.test.com/rstweb.cgi/index.html.fr
</pre>
</div>
<div class="section" id="ce-que-restructweb-n-est-pas">
<h1><a class="toc-backref" href="#id8" name="ce-que-restructweb-n-est-pas">Ce que reStructWeb n'est pas</a></h1>
<p>reStructWeb est juste un petit programme que j'ai écrit pour mes besoins
uniquement. Il n'a pas été pensé et n'est pas du tout adapté à un système
devant être géré par plusieurs personnes. Il n'y a pas de gestion 
d'utilisateurs, pas d'historiques de modifications et les options de
sécurité sont  inexistantes : La permission de modification du site est basé
sur un unique mot de passe, le magicWord :-)</p>
<div class="caution">
<p class="admonition-title first">Avertissement!</p>
<p>Ne laissez pas des utilisateurs anonymes modifier le contenu de votre site.
reStructWeb n'est <strong>pas</strong> un Wiki. Un utilisateur mal-attentionné peut
détourner l'utilisation du reStructuredText pour tenter de compromettre
le système. Exemple :</p>
<pre class="literal-block">
.. include:: /etc/passwd 
</pre>
<p>Il est ainsi possible d'inclure le contenu dans la page de n'importe quel
fichier sur le serveur (pour lequel l'utilisateur d'apache à les droits de
lecture).</p>
</div>
<p>Ceci dit, il est très rapide <a class="footnote-reference" href="#id2" id="id1" name="id1"><sup>1</sup></a> , très léger, très simple à mettre en
oeuvre (un unique fichier et quatre paramètres)</p>
<table class="footnote" frame="void" id="id2" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id1" name="id2">[1]</a></td><td>Ce n'est pas le script reStructWeb qui est rapide, mais l'envoi
par Apache de pages statiques. Ce qui est pratiquement toujours le cas
sur mon site.</td></tr>
</tbody>
</table>
</div>
<div class="section" id="t-l-chargement">
<h1><a class="toc-backref" href="#id9" name="t-l-chargement">Téléchargement</a></h1>
<ul class="simple">
<li>Version 0.1 : <a class="reference" href="st/files/reStructWeb-0.1.tar.gz">download</a></li>
</ul>
</div>
<div class="section" id="configuration">
<h1><a class="toc-backref" href="#id10" name="configuration">Configuration</a></h1>
<div class="section" id="mode-standalone">
<h2><a class="toc-backref" href="#id11" name="mode-standalone">Mode standalone</a></h2>
<p>Dans ce mode, il n'y a rien à configurer au niveau d'apache, il
suffit de copier le script dans le répertoire <tt class="literal"><span class="pre">cgi-bin</span></tt>.</p>
<ol class="arabic simple">
<li>Installer <a class="reference" href="http://docutils.sourceforge.net/">docutils</a>, Télécharger reStructWeb</li>
<li>Copier le fichier <tt class="literal"><span class="pre">rstgen.py</span></tt> dans le répertoire <tt class="literal"><span class="pre">cgi-bin</span></tt></li>
<li>Modifier si besoin les paramètres dans <tt class="literal"><span class="pre">rstgen.py</span></tt></li>
<li>Créer le répertoire de travail de reStructWeb</li>
<li>Donner les bonnes permissions au répertoire (l'utilisateur
de apache doit pouvoir modifier et créer des fichiers dans ce
répertoire)</li>
<li>Copier les fichiers de templates dans le répertoire de travail :
<tt class="literal"><span class="pre">default.tmpl.fr</span></tt>, <tt class="literal"><span class="pre">default.tmpl.en</span></tt></li>
<li>Tester</li>
</ol>
</div>
<div class="section" id="mode-redirection-par-apache">
<h2><a class="toc-backref" href="#id12" name="mode-redirection-par-apache">Mode redirection par Apache</a></h2>
<p>Procéder comme pour le mode standalone et configurer Apache de la
manière suivante :</p>
<pre class="literal-block">
Script GET /cgi-bin/rstgen.py
Script POST /cgi-bin/rstgen.py
ErrorDocument 404 /cgi-bin/rstgen.py
</pre>
</div>
<div class="section" id="ma-configuration">
<h2><a class="toc-backref" href="#id13" name="ma-configuration">Ma configuration</a></h2>
<p>Sur ma machine, le répertoire de travail est <tt class="literal"><span class="pre">/home/web/david/pages</span></tt>,
le script <tt class="literal"><span class="pre">rstgen.py</span></tt> est copié dans le répertoire <tt class="literal"><span class="pre">/home/web/david/cgi-bin</span></tt>.</p>
<p>Voici ma configuration complète:</p>
<pre class="literal-block">
&lt;Directory &quot;/home/web/david/pages&quot;&gt;
      Options FollowSymLinks MultiViews +Includes
      Script GET /drobert/admin
      Script POST /drobert/admin
      ErrorDocument 404 /drobert/admin
      AddDefaultCharset UTF-8
&lt;/Directory&gt;

&lt;Directory &quot;/home/web/david/pages/st&quot;&gt;
      Options Indexes FollowSymLinks MultiViews +Includes
      AddDefaultCharset ISO-8859-1
&lt;/Directory&gt;

&lt;VirtualHost *&gt;
  ServerAdmin webmaster&#64;ombrepixel.com

  DocumentRoot /var/www/ombrepixel.com
  ServerName www.ombrepixel.com
  ServerAlias ombrepixel.com
  ErrorLog logs/www.ombrepixel.com-error_log
  CustomLog logs/www.ombrepixel.com-access_log combined
  ScriptAlias /drobert/admin /home/web/david/cgi-bin/rstgen.py
  Alias /drobert /home/web/david/pages/
&lt;/VirtualHost&gt;
</pre>
</div>
<div class="section" id="templates">
<h2><a class="toc-backref" href="#id14" name="templates">Templates</a></h2>
<div class="section" id="int-ret">
<h3><a class="toc-backref" href="#id15" name="int-ret">Intéret</a></h3>
<p>L'apparance de chaque page peut être totalement personnalisée car le système 
utilise le principe des templates. Ne vous fiez pas à la pauvreté graphique de
ce site. Il est tout à fait possible de faire un site vraiment beau en utilisant
reStructWeb.</p>
<p>Les templates sont des fichiers à l'extension <tt class="literal"><span class="pre">.tmpl</span></tt> situés dans le répertoire
de travail. Il existe au minimun un fichier de template par défaut et par
langue, ainsi, sur mon site, deux fichiers sont présents sur le répertoire de
travail :</p>
<ul class="simple">
<li><tt class="literal"><span class="pre">default.tmpl.fr</span></tt></li>
<li><tt class="literal"><span class="pre">default.tmpl.en</span></tt></li>
</ul>
<p>Ils correspondent aux templates par défaut pour toutes les pages, en français
et en anglais.</p>
<p>Vous pouvez créer des templates spécifiques à chaque page de la forme
<tt class="literal"><span class="pre">nom_page.tmpl.fr</span></tt>. Par exemple si je veux un template particulier pour la
page reStructWeb, il suffit de créer les fichiers <tt class="literal"><span class="pre">restructweb.tmpl.fr</span></tt> et
<tt class="literal"><span class="pre">restructweb.tmpl.en</span></tt>.</p>
</div>
<div class="section" id="balises">
<h3><a class="toc-backref" href="#id16" name="balises">Balises</a></h3>
<p>Le fichier template est un fichier html complet dans lequel un certain nombre
de balises sont remplacées par du contenu dynamique. Actuellement, reStructWeb
permet d'utiliser les balises suivantes :</p>
<table border class="table">
<colgroup>
<col width="37%" />
<col width="63%" />
</colgroup>
<thead valign="bottom">
<tr><th>Balise</th>
<th>Est remplacée par</th>
</tr>
</thead>
<tbody valign="top">
<tr><td><tt class="literal"><span class="pre">$title</span></tt></td>
<td>Titre <a class="footnote-reference" href="#id4" id="id3" name="id3"><sup>2</sup></a> de la page</td>
</tr>
<tr><td><tt class="literal"><span class="pre">$body</span></tt></td>
<td>Corp de la page</td>
</tr>
<tr><td><tt class="literal"><span class="pre">$sourceUrl</span></tt></td>
<td>URL page source</td>
</tr>
<tr><td><tt class="literal"><span class="pre">$editUrl</span></tt></td>
<td>URL d'édition de la page</td>
</tr>
<tr><td><tt class="literal"><span class="pre">$enUrl</span></tt></td>
<td>URL de la version anglaise</td>
</tr>
<tr><td><tt class="literal"><span class="pre">$frUrl</span></tt></td>
<td>URL de la version française</td>
</tr>
<tr><td><tt class="literal"><span class="pre">$lastModified</span></tt></td>
<td>Date de dernière modification</td>
</tr>
</tbody>
</table>
<table class="footnote" frame="void" id="id4" rules="none">
<colgroup><col class="label" /><col /></colgroup>
<tbody valign="top">
<tr><td class="label"><a class="fn-backref" href="#id3" name="id4">[2]</a></td><td>Le titre de la page en <a class="reference" href="http://docutils.sourceforge.net/rst.html">reStructuredText</a> correspond au titre de première 
section</td></tr>
</tbody>
</table>
</div>
</div>
</div>
<div class="section" id="bugs-a-faire">
<h1><a class="toc-backref" href="#id17" name="bugs-a-faire">Bugs / A faire</a></h1>
<ul class="simple">
<li>J'ai remarqué que sous IE en faisant
<a class="reference" href="http://www.ombrepixel.com/drobert/restructweb">http://www.ombrepixel.com/drobert/restructweb</a> on arrive directement
sur le document RST et non HTML</li>
<li>Dictionnaire</li>
<li>Faire une interprétation dynamique des balises d'url pour les autres langues</li>
</ul>
</div>
<div class="section" id="autres-projets">
<h1><a class="toc-backref" href="#id18" name="autres-projets">Autres projets</a></h1>
<ul class="simple">
<li>Ian Bicking reST wiki : <a class="reference" href="http://wiki.webwareforpython.org/thiswiki">http://wiki.webwareforpython.org/thiswiki</a></li>
</ul>
</div>
</div>

<hr class="footer"/>
<div class="footer">
<a href="restructweb.html.fr">reStructWeb 0.1</a> |
<a href="restructweb.txt.fr">Source</a> |
<a href="restructweb.html.fr?action=edit">Editer</a> |
<a href="restructweb.html.en">English version</a>
<img align="right" src="/images/PythonPowered.gif" alt="Powered by Python" />
      <a class="w3" href="http://jigsaw.w3.org/css-validator/"><img align="right"
          src="images/w3c_css.gif" border="0" height="16" width="45" alt="Valid CSS" /> </a>
      <a class="w3" href="http://validator.w3.org/check/referer"><img align="right"
          src="images/w3c_xhtml.gif" border="0" height="16" width="45" alt="Valid XHTML 1.0!" /> </a>
<br />
<a href="mailto:david@ombrepixel.com">Me contacter</a> <br />
Dernières modification: 2004-05-24 14:04:06 CEST
</div>
</body>
</html>
